/**
 * sample cgi application
 * Show a greet message from a specific file cgi_view.txt
 * file name: cgi_view.c
 */
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
	int fd;
	char buf[1000];
	int ret;

	/* コンテントタイプとヘッダー出力 */
	printf("Content-type: text/html\n\n");
	printf("<HTML>\n");
	printf("<HEAD>\n<TITLE>cgi_view</TITLE>\n</HEAD>\n<BODY>\n");

	/* ファイル(cgi_view.txt)を読み取り専用で開く */
	fd = open("/var/tmp/cgi_view.txt", O_RDONLY);
	if (fd < 0) {
		printf("open error\n");
		printf("</BODY>\n</HTML>\n");
		exit(1);
	}

	/* ファイルから最大bufの大きさまで読み取り */
	ret = read(fd, buf, sizeof(buf)-1);
	buf[sizeof(buf)-1] = '\0';
	if (ret < 0) {
		printf("read error\n");
		printf("</BODY>\n</HTML>\n");
		exit(1);
	}

	/* 読み取った文字列を本文として出力 */
	printf("%s", buf);
	printf("</BODY>\n</HTML>\n");

	/* ファイルを閉じる */
	close(fd);

	return 0;
}

